#ifndef ABORT_H
#define ABORT_H
#include "common.h"
#include "Entry.h"
#include "Pair.h"

class Abort : public Entry {
 private:
	int64_t transactionClientLocalSequenceNumber;
  int64_t transactionSequenceNumber;
	int64_t sequenceNumber;
	int64_t transactionMachineId;
	int64_t transactionArbitrator;
	int64_t arbitratorLocalSequenceNumber;
	Pair<int64_t, int64_t> * abortId;
  
 public:
	Abort(Slot * slot, int64_t _transactionClientLocalSequenceNumber, int64_t _transactionSequenceNumber ,  int64_t _transactionMachineId, int64_t _transactionArbitrator, int64_t _arbitratorLocalSequenceNumber);
  Abort(Slot * slot, int64_t _transactionClientLocalSequenceNumber, int64_t _transactionSequenceNumber, int64_t _sequenceNumber ,  int64_t _transactionMachineId, int64_t _transactionArbitrator, int64_t _arbitratorLocalSequenceNumber);

	Pair<int64_t, int64_t> * getAbortId() {return abortId;}
  
	int64_t getTransactionMachineId() { return transactionMachineId; }
	int64_t getTransactionSequenceNumber()  { return transactionSequenceNumber; }
	int64_t getTransactionClientLocalSequenceNumber() { return transactionClientLocalSequenceNumber; }
	int64_t getArbitratorLocalSequenceNumber() { return arbitratorLocalSequenceNumber; }
	void setSlot(Slot * s) { parentslot = s; }
	int64_t getSequenceNumber() { return sequenceNumber;	}
	void setSequenceNumber(int64_t _sequenceNumber) { sequenceNumber = _sequenceNumber; }
	int64_t getTransactionArbitrator() { return transactionArbitrator; }

	void encode(ByteBuffer * bb);
	int getSize() { return (6 * sizeof(uint64_t)) + sizeof(char); }
	char getType() { return TypeAbort; }
	Entry * getCopy(Slot * s) { return new Abort(s, transactionClientLocalSequenceNumber, transactionSequenceNumber, sequenceNumber, transactionMachineId, transactionArbitrator, arbitratorLocalSequenceNumber); }
};

Entry * Abortdecode(Slot * slot, ByteBuffer * bb);
#endif
