#ifndef ARBITRATIONROUND_H
#define ARBITRATIONROUND_H

#define MAX_PARTS 10
#include "common.h"

class ArbitrationRound {
 private:
  Hashset<Abort *> * abortsBefore;
  Vector<Entry *> * parts;
  Commit * commit;
  int currentSize;
  bool didSendPart;
  bool didGenerateParts;

 public:
  ArbitrationRound(Commit * _commit, Hashset<Abort *> * _abortsBefore);
	~ArbitrationRound();
  void generateParts();
  Vector<Entry *> * getParts();
  void removeParts(Vector<Entry *> * removeParts);
  bool isDoneSending();
  void setCommit(Commit * _commit);
  void addAbort(Abort * abort);
  void addAborts(Hashset<Abort *> * aborts);
  Hashset<Abort *> * getAborts();
  int getAbortsCount();
  int getCurrentSize();
  bool isFull();
  bool getDidSendPart();
};

#endif
