#ifndef ARRAY_H
#define ARRAY_H
#include <inttypes.h>

typedef uint32_t uint;

template<typename type>
class Array {
 public:
 Array() :
  array(NULL),
    size(0) {
  }
  
 Array(uint32_t _size) :
  array((type *) ourcalloc(1, sizeof(type) * _size)),
		size(_size)
    {
    }
  
 Array(type *_array, uint _size) :
  array((type *) ourmalloc(sizeof(type) * _size)),
		size(_size) {
      memcpy(array, _array, _size * sizeof(type));
    }

 Array(Array<type> *_array) :
	array((type *) ourmalloc(sizeof(type) * _array->size)),
		size(_array->size) {
		memcpy(array, _array->array, size * sizeof(type));
	}
	
	void init(uint _size) {
		array = (type *) ourcalloc(1, sizeof(type) * _size);
		size = _size;
	}

	void init(type *_array, uint _size) {
		array = (type *) ourmalloc(sizeof(type) * _size);
		size = _size;
		memcpy(array, _array, _size * sizeof(type));
	}
	
	void init(Array<type> *_array) {
		array = (type *) ourmalloc(sizeof(type) * _array->size);
		size = _array->size;
		memcpy(array, _array->array, size * sizeof(type));
	}
	
	~Array() {
		if (array)
			ourfree(array);
	}
	
	type get(uint index) const {
		return array[index];
	}
	
	void set(uint index, type item) {
		array[index] = item;
	}
	
	uint length() const {
		return size;
	}

	type *internalArray() {
		return array;
	}
	
 private:
	type *array;
	uint size;
};
#endif
